//---------------------------------------------------------------------------
#ifndef commonH
#define commonH
//---------------------------------------------------------------------------
#define PROG_NAME             "Quido"
#define PROG_VERSION          0x10
#define PROG_AUTHOR           "Roman Borik 04/2010"

//---------------------------------------------------------------------------
#define BYTE                  unsigned char
#define WORD                  unsigned short int
#define BOOL                  int
#define FALSE                 0
#define TRUE                  !FALSE

//---------------------------------------------------------------------------
#define PACK_MODE_1           1
#define PACK_MODE_2           2
#define PACK_MODE_3           4
#define PACK_MODE_4           8
#define MAX_FILE_LENGTH       49152

//---------------------------------------------------------------------------
#define ERR_PRINT_USAGE       -1
#define ERR_PRINT_VERSION     -2
#define ERR_BAD_OPTIONS       -3
#define ERR_BAD_PACK_MODE     -4
#define ERR_OPEN_SRC_FILE     -5
#define ERR_ACCESS_SRC_FILE   -6
#define ERR_LENGTH_SRC_FILE   -7
#define ERR_READ_SRC_FILE     -8
#define ERR_OPEN_DEST_FILE    -9
#define ERR_ACCESS_DEST_FILE  -10
#define ERR_WRITE_DEST_FILE   -11
#define ERR_BAD_COLOR_VALUE   -12
#define ERR_BAD_ADDRESS       -13
#define ERR_BAD_UNPACK_ADDR   -14
#define ERR_INEFFECTIVE       -15
#define ERR_NO_INPUT_FILE     -16
#define ERR_INPUT_FILE_MORE   -17
#define ERR_OUTPUT_FILE_MORE  -18

//---------------------------------------------------------------------------
// pack.c
int pack(BYTE *buffer, int length, int packMode);

// zxstape.c
void getRoutinesLengthZ80(int *len);
void constructBasicZX(BYTE **out, int *col, int clear, BOOL poke, char *name,
                      BOOL d80, int run);
void constructCodeZX(BYTE **out, BYTE *packed, int packLen, int oldLen, int mode,
                     char *name, int targetAddr, int unpackRtnAddr, int jumpAddr);
void constructBinZ80(BYTE **out, BYTE *packed, int packLen, int oldLen, int mode,
                     int targetAddr, int unpackRtnAddr, int jumpAddr);

// pmdtape.c
void getRoutinesLengthI8080(int *len, BOOL vram);
void constructBinI8080(BYTE **out, BYTE *packed, int packLen, int oldLen, int mode,
                       BOOL vram, int targetAddr, int unpackRtnAddr, int jumpAddr);
void constructCodePMD(BYTE **out, BYTE *packed, int packLen, int oldLen,
                      char *name, int mode, BOOL vram,
                      int targetAddr, int unpackRtnAddr, int jumpAddr);

//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------

 